#include "stdafx.h"
#include "windows.h"
#include <stdio.h>
#include "conio.h"
#include "winio.h"
#include <string.h>

enum {SPP8=0,EPP17,EPP19};

#define STR_SIZE (256)
static char line[STR_SIZE];
unsigned char PortVal;

int CmdLn(int argc, char* argv[]);
unsigned char ReadData(int PortAddr, int PortMode);
void WriteAddr(int PortAddr, unsigned char val, int PortMode);

int dwPortVal = 0x378;
int dwPPM510_MODE = 0x0;

int main(int argc, char* argv[])
{
	int nRetCode = 0;
	int bResult = 0;

	if(!CmdLn(argc, argv))
		return nRetCode;

	bResult = InitializeWinIo();
	if(bResult)
	{
		printf("\nOk open LPT port %x\n",dwPortVal);
	}
	else
	{
		printf("\nError open LPT port\n");
		return (-1);
	}

	printf("\nOk\n");
	WriteAddr(dwPortVal, dwPPM510_MODE, SPP8);
	//PortVal = ReadData(dwPortVal, SPP8);
	if(bResult)
		ShutdownWinIo();
	return (1);
}

void WriteAddr(int PortAddr, unsigned char val, int PortMode)
{
	switch(PortMode)
	{
		case SPP8:
			/*Set data bus*/
				SetPortVal(PortAddr, (int)val, 1);
			/*Set strobbe*/
				SetPortVal(PortAddr+2, (int)0x0c, 1);
				SetPortVal(PortAddr+2, (int)0x04, 1);
			break;
	}
}

unsigned char ReadData(int PortAddr, int PortMode)
{
 int data = 0;
	switch(PortMode)
	{
		case SPP8:
			/*Set strobbe*/
				SetPortVal(PortAddr+2, (int)0xA0, 1);
			/*Get data bus*/
				GetPortVal(PortAddr, (PDWORD)&data, 1);
			/*Set strobbe*/
				SetPortVal(PortAddr+2, (int)0xA1, 1);
				SetPortVal(PortAddr+2, (int)0xA0, 1);
			break;
	}

	return data;
}

int CmdLn(int argc, char* argv[])
{

  int i = 1;
	if(argc>1)
	{
	if( argv[i][0] != '-' )
		{
		printf("Error command line. Use ppm510.exe -h \n");
		printf("\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\n");
		printf( "  -b LPT address(hex)    : ByteBlasterMV\n");
		printf( "  -x LPT address(hex)    : Xilinx JTAG\n");
		printf( "  -p LPT address(hex)    : PonyProg\n");
		printf( "  -m LPT address(hex)    : MSP430 JTAG\n");
		printf( "  -a LPT address(hex)    : ARM Wiggler JTAG\n");
		return 0;
		}
	else
	{
		switch(tolower(argv[i][1]))
		{
			case 'h':
			case '?':
				printf( "\n");
				printf( "  -?,h                   : Displays command line help info.\n");
				printf( "  -b LPT address(hex)    : ByteBlasterMV\n");
					 	printf( "\t(TCK pin 1)\n");
					 	printf( "\t(TMS pin 5)\n");
					 	printf( "\t(TDI pin 9)\n");
						printf( "\t(TDO pin 3)\n\n");

				printf( "  -x LPT address(hex)    : Xilinx JTAG\n");
					 	printf( "\t(TCK pin 1)\n");
					 	printf( "\t(TMS pin 5)\n");
					 	printf( "\t(TDI pin 9)\n");
						printf( "\t(TDO pin 3)\n\n");

				printf( "  -p LPT address(hex)    : PonyProg\n");
					 	printf( "\t(TCK pin 1)/(SCK pin 4)\n");
					 	printf( "\t(TMS pin 5)/(RST pin 2,3)\n");
					 	printf( "\t(TDI pin 9)/(MOSI pin 5)\n");
						printf( "\t(TDO pin 3)/(MISO pin 6)\n\n");

				printf( "  -m LPT address(hex)    : MSP430 JTAG\n");
					printf( "\t(TCK pin 1)/(TCK pin 7)\n");
					printf( "\t(TMS pin 5)/(TMS pin 5)\n");
					printf( "\t(TDI pin 9)/(TDI pin 3)\n");
					printf( "\t(P_O pin 6)/(TCLK pin 6)\n");
					printf( "\t(DO0 pin 8)/(RST pin 11)\n");
					printf( "\t(TDO pin 3)/(TDO pin 1)\n\n");

				printf( "  -a LPT address(hex)    : ARM Wiggler JTAG\n");
					 printf( "\t(TCK pin 1)/(TCK pin 9/IDC14)/(TCK pin 9/IDC20)\n");
					 printf( "\t(TMS pin 5)/(TMS pin 7/IDC14)(TMS pin 7/IDC20)\n");
					 printf( "\t(TDI pin 9)/(TDI pin 5/IDC14)(TDI pin 5/IDC20)\n");
					 printf("\t(P_O pin 6)/(SRST pin 3/IDC14)(SRST pin 3/IDC20)\n");
					 printf("\t(TDO pin 3)/(TDO pin 11/IDC14)(TDO pin 13/IDC20)\n");
					 printf("\t(VCC pin 1)/(VCC pin 1/IDC14)(VCC pin 1/IDC20)\n");

					
				printf("Version 1.00,  March 2005");
				break;
				case 'b':
					if(argv[2])
					{
						sscanf(argv[2],"%x",&dwPortVal);
					}
						dwPPM510_MODE = 0x0;
						printf("\n\nByteBlasterMV\n\n");

					break;
				case 'x':
					if(argv[2])
					{
						sscanf(argv[2],"%x",&dwPortVal);
					}
						dwPPM510_MODE = 0x1;
						printf("\n\nXilinx JTAG\n\n");
					break;
				case 'p':
					if(argv[2])
					{
						sscanf(argv[2],"%x",&dwPortVal);
					}
						dwPPM510_MODE = 0x2;
						printf("\n\nPonyProg\n\n");
					break;

				case 'm':
					if(argv[2])
					{
						sscanf(argv[2],"%x",&dwPortVal);
					}
						dwPPM510_MODE = 0x3;
						printf("\n\nMSP430 JTAG\n\n");
					break;

				case 'a':
					if(argv[2])
					{
						sscanf(argv[2],"%x",&dwPortVal);
					}
						dwPPM510_MODE = 0x4;
						printf("\n\nARM Wiggler JTAG\n\n");
					break;

				default:
				printf("Error command line. Use -?");
		}
	}
	}
	else
	{
		printf("Error command line. Use dat.exe -h \n");
		return false;
	}
	return 1;
}
